import * as graphql_jsutils_Maybe_js from 'graphql/jsutils/Maybe.js';
import * as graphql_jsutils_ObjMap_js from 'graphql/jsutils/ObjMap.js';
import * as graphql from 'graphql';
import { GraphQLOutputType, GraphQLNamedType, TokenKind, Token, Location } from 'graphql';
import { AST } from 'eslint';
import { Comment, SourceLocation } from 'estree';

declare const valueFromNode: (valueNode: graphql.ValueNode, variables?: graphql_jsutils_Maybe_js.Maybe<graphql_jsutils_ObjMap_js.ObjMap<unknown>>) => any;
declare function getBaseType(type: GraphQLOutputType): GraphQLNamedType;
declare function convertToken<T extends TokenKind | 'Block' | 'Line'>(token: Token, type: T): Omit<AST.Token, 'type'> & {
    type: T;
};
declare function extractTokens(filePath: string, code: string): AST.Token[];
declare function extractComments(loc?: Location): Comment[];
declare function convertLocation(location: Location): SourceLocation;

export { convertLocation, convertToken, extractComments, extractTokens, getBaseType, valueFromNode };
