declare const _default: {
    parser: string;
    plugins: string[];
    rules: {
        '@graphql-eslint/description-style': "error";
        '@graphql-eslint/known-argument-names': "error";
        '@graphql-eslint/known-directives': "error";
        '@graphql-eslint/known-type-names': "error";
        '@graphql-eslint/lone-schema-definition': "error";
        '@graphql-eslint/naming-convention': ["error", {
            types: string;
            FieldDefinition: string;
            InputValueDefinition: string;
            Argument: string;
            DirectiveDefinition: string;
            EnumValueDefinition: string;
            'FieldDefinition[parent.name.value=Query]': {
                forbiddenPrefixes: string[];
                forbiddenSuffixes: string[];
            };
            'FieldDefinition[parent.name.value=Mutation]': {
                forbiddenPrefixes: string[];
                forbiddenSuffixes: string[];
            };
            'FieldDefinition[parent.name.value=Subscription]': {
                forbiddenPrefixes: string[];
                forbiddenSuffixes: string[];
            };
            'EnumTypeDefinition,EnumTypeExtension': {
                forbiddenPrefixes: string[];
                forbiddenSuffixes: string[];
            };
            'InterfaceTypeDefinition,InterfaceTypeExtension': {
                forbiddenPrefixes: string[];
                forbiddenSuffixes: string[];
            };
            'UnionTypeDefinition,UnionTypeExtension': {
                forbiddenPrefixes: string[];
                forbiddenSuffixes: string[];
            };
            'ObjectTypeDefinition,ObjectTypeExtension': {
                forbiddenPrefixes: string[];
                forbiddenSuffixes: string[];
            };
        }];
        '@graphql-eslint/no-hashtag-description': "error";
        '@graphql-eslint/no-typename-prefix': "error";
        '@graphql-eslint/no-unreachable-types': "error";
        '@graphql-eslint/possible-type-extension': "error";
        '@graphql-eslint/provided-required-arguments': "error";
        '@graphql-eslint/require-deprecation-reason': "error";
        '@graphql-eslint/require-description': ["error", {
            types: boolean;
            DirectiveDefinition: boolean;
            rootField: boolean;
        }];
        '@graphql-eslint/strict-id-in-types': "error";
        '@graphql-eslint/unique-directive-names': "error";
        '@graphql-eslint/unique-directive-names-per-location': "error";
        '@graphql-eslint/unique-enum-value-names': "error";
        '@graphql-eslint/unique-field-definition-names': "error";
        '@graphql-eslint/unique-operation-types': "error";
        '@graphql-eslint/unique-type-names': "error";
    };
};

export { _default as default };
