import { OperationTypeNode } from 'graphql';
import { FromSchema } from 'json-schema-to-ts';
import { GraphQLESLintRule } from '../../types.js';
import 'eslint';
import 'estree';
import 'graphql-config';
import '../../estree-converter/types.js';
import '../../siblings.js';
import '@graphql-tools/utils';

declare const schema: {
    readonly type: "array";
    readonly maxItems: 1;
    readonly items: {
        readonly type: "object";
        readonly minProperties: 1;
        readonly additionalProperties: false;
        readonly properties: {
            readonly ignore: {
                readonly maxItems: 3;
                readonly items: {
                    readonly enum: readonly ["fragment", ...OperationTypeNode[]];
                };
                readonly description: "Allow certain definitions to be placed alongside others.";
                readonly type: "array";
                readonly uniqueItems: true;
                readonly minItems: 1;
            };
        };
    };
};
type RuleOptions = FromSchema<typeof schema>;
declare const rule: GraphQLESLintRule<RuleOptions>;

export { type RuleOptions, rule };
