import { FromSchema } from 'json-schema-to-ts';
import { GraphQLESLintRule } from '../../types.js';
import 'eslint';
import 'estree';
import 'graphql';
import 'graphql-config';
import '../../estree-converter/types.js';
import '../../siblings.js';
import '@graphql-tools/utils';

declare const schema: {
    readonly type: "array";
    readonly minItems: 1;
    readonly maxItems: 1;
    readonly items: {
        readonly type: "object";
        readonly additionalProperties: false;
        readonly required: readonly ["disallow"];
        readonly properties: {
            readonly disallow: {
                readonly items: {
                    readonly enum: readonly ["mutation", "subscription"];
                };
                readonly type: "array";
                readonly uniqueItems: true;
                readonly minItems: 1;
            };
        };
    };
};
type RuleOptions = FromSchema<typeof schema>;
declare const rule: GraphQLESLintRule<RuleOptions>;

export { type RuleOptions, rule };
